/*
  * UAE - The Un*x Amiga Emulator
  *
  * Definitions for accessing cycle counters on a given machine, if possible.
  *
  * Copyright 1997, 1998 Bernd Schmidt
  * Copyright 1999 Brian King - Win32 specific
  */
#ifndef _RPT_H_
#define _RPT_H_

typedef unsigned long frame_time_t;

/* For Cyrix users, who lack the rdtsc instruction */
extern frame_time_t read_processor_time_cyrix( void );
extern int useqpc;

#if defined( __GNUC__ )
static inline frame_time_t read_processor_time (void)
{
    frame_time_t foo;
    int dummy;

    if( useqpc )
        return read_processor_time_cyrix();

    /* Don't assume the assembler knows rdtsc */
    __asm__ __volatile__ (".byte 0x0f,0x31" : "=a" (foo), "=d" (dummy) :);
    return foo;
}
#elif defined( __WATCOMC__ )
extern frame_time_t read_processor_time (void);
#pragma aux read_processor_time = \
 "rdtsc" \
 modify [eax edx] value [eax];
#elif defined( _MSC_VER ) && !defined( _WIN32_WCE )
static __inline frame_time_t read_processor_time (void)
{
    frame_time_t foo;
    int bar;

    if( useqpc )
	return read_processor_time_cyrix();

     __asm
    {
        rdtsc
        mov foo, eax
        mov bar, edx
    }
    return foo;
}
#else
static __inline__ frame_time_t read_processor_time (void)
{
    return 0;
}
#endif

#endif
